/*
* React Tooltip
* {@link https://github.com/ReactTooltip/react-tooltip}
* @copyright ReactTooltip Team
* @license MIT
*/
import e,{createContext as t,useState as r,useCallback as n,useMemo as o,useContext as l,useRef as c,useEffect as i,useLayoutEffect as s}from"react";import a from"classnames";import{arrow as u,computePosition as d,offset as p,flip as m,shift as v}from"@floating-ui/dom";const f="react-tooltip-core-styles",h="react-tooltip-base-styles";function y({css:e,id:t=h,type:r="base",ref:n}){if("core"===r&&process.env.REACT_TOOLTIP_DISABLE_CORE_STYLES)return;if("core"!==r&&process.env.REACT_TOOLTIP_DISABLE_BASE_STYLES)return;"core"===r&&(t=f),n||(n={});const{insertAt:o}=n;if(!e||"undefined"==typeof document||document.getElementById(t))return;const l=document.head||document.getElementsByTagName("head")[0],c=document.createElement("style");c.id=t,c.type="text/css","top"===o&&l.firstChild?l.insertBefore(c,l.firstChild):l.appendChild(c),c.styleSheet?c.styleSheet.cssText=e:c.appendChild(document.createTextNode(e))}function w({type:e="base",id:t=h}){"core"===e&&(t=f);const r=document.getElementById(t);null==r||r.remove()}const S=(e,t,r)=>{let n=null;return function(...o){const l=()=>{n=null,r||e.apply(this,o)};r&&!n&&(e.apply(this,o),n=setTimeout(l,t)),r||(n&&clearTimeout(n),n=setTimeout(l,t))}},E="DEFAULT_TOOLTIP_ID",_={anchorRefs:new Set,activeAnchor:{current:null},attach:()=>{},detach:()=>{},setActiveAnchor:()=>{}},g=t({getTooltipData:()=>_}),A=({children:t})=>{const[l,c]=r({[E]:new Set}),[i,s]=r({[E]:{current:null}}),a=(e,...t)=>{c((r=>{var n;const o=null!==(n=r[e])&&void 0!==n?n:new Set;return t.forEach((e=>o.add(e))),{...r,[e]:new Set(o)}}))},u=(e,...t)=>{c((r=>{const n=r[e];return n?(t.forEach((e=>n.delete(e))),{...r}):r}))},d=n(((e=E)=>{var t,r;return{anchorRefs:null!==(t=l[e])&&void 0!==t?t:new Set,activeAnchor:null!==(r=i[e])&&void 0!==r?r:{current:null},attach:(...t)=>a(e,...t),detach:(...t)=>u(e,...t),setActiveAnchor:t=>((e,t)=>{s((r=>{var n;return(null===(n=r[e])||void 0===n?void 0:n.current)===t.current?r:{...r,[e]:t}}))})(e,t)}}),[l,i,a,u]),p=o((()=>({getTooltipData:d})),[d]);return e.createElement(g.Provider,{value:p},t)};function b(e=E){return l(g).getTooltipData(e)}const T=({tooltipId:t,children:r,className:n,place:o,content:l,html:s,variant:u,offset:d,wrapper:p,events:m,positionStrategy:v,delayShow:f,delayHide:h})=>{const{attach:y,detach:w}=b(t),S=c(null);return i((()=>(y(S),()=>{w(S)})),[]),e.createElement("span",{ref:S,className:a("react-tooltip-wrapper",n),"data-tooltip-place":o,"data-tooltip-content":l,"data-tooltip-html":s,"data-tooltip-variant":u,"data-tooltip-offset":d,"data-tooltip-wrapper":p,"data-tooltip-events":m,"data-tooltip-position-strategy":v,"data-tooltip-delay-show":f,"data-tooltip-delay-hide":h},r)},O="undefined"!=typeof window?s:i,L=e=>{if(!(e instanceof HTMLElement||e instanceof SVGElement))return!1;const t=getComputedStyle(e);return["overflow","overflow-x","overflow-y"].some((e=>{const r=t.getPropertyValue(e);return"auto"===r||"scroll"===r}))},R=e=>{if(!e)return null;let t=e.parentElement;for(;t;){if(L(t))return t;t=t.parentElement}return document.scrollingElement||document.documentElement},k=async({elementReference:e=null,tooltipReference:t=null,tooltipArrowReference:r=null,place:n="top",offset:o=10,strategy:l="absolute",middlewares:c=[p(Number(o)),m(),v({padding:5})]})=>{if(!e)return{tooltipStyles:{},tooltipArrowStyles:{},place:n};if(null===t)return{tooltipStyles:{},tooltipArrowStyles:{},place:n};const i=c;return r?(i.push(u({element:r,padding:5})),d(e,t,{placement:n,strategy:l,middleware:i}).then((({x:e,y:t,placement:r,middlewareData:n})=>{var o,l;const c={left:`${e}px`,top:`${t}px`},{x:i,y:s}=null!==(o=n.arrow)&&void 0!==o?o:{x:0,y:0};return{tooltipStyles:c,tooltipArrowStyles:{left:null!=i?`${i}px`:"",top:null!=s?`${s}px`:"",right:"",bottom:"",[null!==(l={top:"bottom",right:"left",bottom:"top",left:"right"}[r.split("-")[0]])&&void 0!==l?l:"bottom"]:"-4px"},place:r}}))):d(e,t,{placement:"bottom",strategy:l,middleware:i}).then((({x:e,y:t,placement:r})=>({tooltipStyles:{left:`${e}px`,top:`${t}px`},tooltipArrowStyles:{},place:r})))};var N="core-styles-module_tooltip__3vRRp",x="core-styles-module_fixed__pcSol",I="core-styles-module_arrow__cvMwQ",C="core-styles-module_noArrow__xock6",$="core-styles-module_clickable__ZuTTB",B="core-styles-module_show__Nt9eE",H={arrow:"styles-module_arrow__K0L3T",dark:"styles-module_dark__xNqje",light:"styles-module_light__Z6W-X",success:"styles-module_success__A2AKt",warning:"styles-module_warning__SCK0X",error:"styles-module_error__JvumD",info:"styles-module_info__BWdHW"};const D=({id:t,className:n,classNameArrow:o,variant:l="dark",anchorId:s,anchorSelect:u,place:d="top",offset:p=10,events:m=["hover"],openOnClick:v=!1,positionStrategy:f="absolute",middlewares:h,wrapper:y,delayShow:w=0,delayHide:E=0,float:_=!1,hidden:g=!1,noArrow:A=!1,clickable:T=!1,closeOnEsc:L=!1,closeOnScroll:D=!1,closeOnResize:j=!1,style:q,position:z,afterShow:W,afterHide:M,content:P,contentWrapperRef:K,isOpen:X,setIsOpen:Y,activeAnchor:F,setActiveAnchor:V})=>{const Z=c(null),G=c(null),J=c(null),Q=c(null),[U,ee]=r(d),[te,re]=r({}),[ne,oe]=r({}),[le,ce]=r(!1),[ie,se]=r(!1),ae=c(!1),ue=c(null),{anchorRefs:de,setActiveAnchor:pe}=b(t),me=c(!1),[ve,fe]=r([]),he=c(!1),ye=v||m.includes("click");O((()=>(he.current=!0,()=>{he.current=!1})),[]),i((()=>{if(!le){const e=setTimeout((()=>{se(!1)}),150);return()=>{clearTimeout(e)}}return()=>null}),[le]);const we=e=>{he.current&&(e&&se(!0),setTimeout((()=>{he.current&&(null==Y||Y(e),void 0===X&&ce(e))}),10))};i((()=>{if(void 0===X)return()=>null;X&&se(!0);const e=setTimeout((()=>{ce(X)}),10);return()=>{clearTimeout(e)}}),[X]),i((()=>{le!==ae.current&&(ae.current=le,le?null==W||W():null==M||M())}),[le]);const Se=(e=E)=>{Q.current&&clearTimeout(Q.current),Q.current=setTimeout((()=>{me.current||we(!1)}),e)},Ee=e=>{var t;if(!e)return;const r=null!==(t=e.currentTarget)&&void 0!==t?t:e.target;if(!(null==r?void 0:r.isConnected))return V(null),void pe({current:null});w?(J.current&&clearTimeout(J.current),J.current=setTimeout((()=>{we(!0)}),w)):we(!0),V(r),pe({current:r}),Q.current&&clearTimeout(Q.current)},_e=()=>{T?Se(E||100):E?Se():we(!1),J.current&&clearTimeout(J.current)},ge=({x:e,y:t})=>{k({place:d,offset:p,elementReference:{getBoundingClientRect:()=>({x:e,y:t,width:0,height:0,top:t,left:e,right:e,bottom:t})},tooltipReference:Z.current,tooltipArrowReference:G.current,strategy:f,middlewares:h}).then((e=>{Object.keys(e.tooltipStyles).length&&re(e.tooltipStyles),Object.keys(e.tooltipArrowStyles).length&&oe(e.tooltipArrowStyles),ee(e.place)}))},Ae=e=>{if(!e)return;const t=e,r={x:t.clientX,y:t.clientY};ge(r),ue.current=r},be=e=>{Ee(e),E&&Se()},Te=e=>{var t;[document.querySelector(`[id='${s}']`),...ve].some((t=>null==t?void 0:t.contains(e.target)))||(null===(t=Z.current)||void 0===t?void 0:t.contains(e.target))||(we(!1),J.current&&clearTimeout(J.current))},Oe=S(Ee,50,!0),Le=S(_e,50,!0);i((()=>{var e,t;const r=new Set(de);ve.forEach((e=>{r.add({current:e})}));const n=document.querySelector(`[id='${s}']`);n&&r.add({current:n});const o=()=>{we(!1)},l=R(F),c=R(Z.current);D&&(window.addEventListener("scroll",o),null==l||l.addEventListener("scroll",o),null==c||c.addEventListener("scroll",o)),j&&window.addEventListener("resize",o);const i=e=>{"Escape"===e.key&&we(!1)};L&&window.addEventListener("keydown",i);const a=[];ye?(window.addEventListener("click",Te),a.push({event:"click",listener:be})):(a.push({event:"mouseenter",listener:Oe},{event:"mouseleave",listener:Le},{event:"focus",listener:Oe},{event:"blur",listener:Le}),_&&a.push({event:"mousemove",listener:Ae}));const u=()=>{me.current=!0},d=()=>{me.current=!1,_e()};return T&&!ye&&(null===(e=Z.current)||void 0===e||e.addEventListener("mouseenter",u),null===(t=Z.current)||void 0===t||t.addEventListener("mouseleave",d)),a.forEach((({event:e,listener:t})=>{r.forEach((r=>{var n;null===(n=r.current)||void 0===n||n.addEventListener(e,t)}))})),()=>{var e,t;D&&(window.removeEventListener("scroll",o),null==l||l.removeEventListener("scroll",o),null==c||c.removeEventListener("scroll",o)),j&&window.removeEventListener("resize",o),ye&&window.removeEventListener("click",Te),L&&window.removeEventListener("keydown",i),T&&!ye&&(null===(e=Z.current)||void 0===e||e.removeEventListener("mouseenter",u),null===(t=Z.current)||void 0===t||t.removeEventListener("mouseleave",d)),a.forEach((({event:e,listener:t})=>{r.forEach((r=>{var n;null===(n=r.current)||void 0===n||n.removeEventListener(e,t)}))}))}}),[ie,de,ve,L,m]),i((()=>{let e=null!=u?u:"";!e&&t&&(e=`[data-tooltip-id='${t}']`);const r=new MutationObserver((r=>{const n=[];r.forEach((r=>{if("attributes"===r.type&&"data-tooltip-id"===r.attributeName){r.target.getAttribute("data-tooltip-id")===t&&n.push(r.target)}if("childList"===r.type&&(F&&[...r.removedNodes].some((e=>{var t;return!!(null===(t=null==e?void 0:e.contains)||void 0===t?void 0:t.call(e,F))&&(se(!1),we(!1),V(null),J.current&&clearTimeout(J.current),Q.current&&clearTimeout(Q.current),!0)})),e))try{const t=[...r.addedNodes].filter((e=>1===e.nodeType));n.push(...t.filter((t=>t.matches(e)))),n.push(...t.flatMap((t=>[...t.querySelectorAll(e)])))}catch(e){}})),n.length&&fe((e=>[...e,...n]))}));return r.observe(document.body,{childList:!0,subtree:!0,attributes:!0,attributeFilter:["data-tooltip-id"]}),()=>{r.disconnect()}}),[t,u,F]);const Re=()=>{z?ge(z):_?ue.current&&ge(ue.current):k({place:d,offset:p,elementReference:F,tooltipReference:Z.current,tooltipArrowReference:G.current,strategy:f,middlewares:h}).then((e=>{he.current&&(Object.keys(e.tooltipStyles).length&&re(e.tooltipStyles),Object.keys(e.tooltipArrowStyles).length&&oe(e.tooltipArrowStyles),ee(e.place))}))};i((()=>{Re()}),[le,F,P,q,d,p,f,z]),i((()=>{if(!(null==K?void 0:K.current))return()=>null;const e=new ResizeObserver((()=>{Re()}));return e.observe(K.current),()=>{e.disconnect()}}),[P,null==K?void 0:K.current]),i((()=>{var e;const t=document.querySelector(`[id='${s}']`),r=[...ve,t];F&&r.includes(F)||V(null!==(e=ve[0])&&void 0!==e?e:t)}),[s,ve,F]),i((()=>()=>{J.current&&clearTimeout(J.current),Q.current&&clearTimeout(Q.current)}),[]),i((()=>{let e=u;if(!e&&t&&(e=`[data-tooltip-id='${t}']`),e)try{const t=Array.from(document.querySelectorAll(e));fe(t)}catch(e){fe([])}}),[t,u]);const ke=!g&&P&&le&&Object.keys(te).length>0;return ie?e.createElement(y,{id:t,role:"tooltip",className:a("react-tooltip",N,H[l],n,`react-tooltip__place-${U}`,{[B]:ke,[x]:"fixed"===f,[$]:T}),style:{...q,...te},ref:Z},P,e.createElement(y,{className:a("react-tooltip-arrow",I,H.arrow,o,{[C]:A}),style:ne,ref:G})):null},j=({content:t})=>e.createElement("span",{dangerouslySetInnerHTML:{__html:t}}),q=({id:t,anchorId:n,anchorSelect:o,content:l,html:s,render:a,className:u,classNameArrow:d,variant:p="dark",place:m="top",offset:v=10,wrapper:f="div",children:h=null,events:y=["hover"],openOnClick:w=!1,positionStrategy:S="absolute",middlewares:E,delayShow:_=0,delayHide:g=0,float:A=!1,hidden:T=!1,noArrow:O=!1,clickable:L=!1,closeOnEsc:R=!1,closeOnScroll:k=!1,closeOnResize:N=!1,style:x,position:I,isOpen:C,setIsOpen:$,afterShow:B,afterHide:H})=>{const[q,z]=r(l),[W,M]=r(s),[P,K]=r(m),[X,Y]=r(p),[F,V]=r(v),[Z,G]=r(_),[J,Q]=r(g),[U,ee]=r(A),[te,re]=r(T),[ne,oe]=r(f),[le,ce]=r(y),[ie,se]=r(S),[ae,ue]=r(null),{anchorRefs:de,activeAnchor:pe}=b(t),me=e=>null==e?void 0:e.getAttributeNames().reduce(((t,r)=>{var n;if(r.startsWith("data-tooltip-")){t[r.replace(/^data-tooltip-/,"")]=null!==(n=null==e?void 0:e.getAttribute(r))&&void 0!==n?n:null}return t}),{}),ve=e=>{const t={place:e=>{var t;K(null!==(t=e)&&void 0!==t?t:m)},content:e=>{z(null!=e?e:l)},html:e=>{M(null!=e?e:s)},variant:e=>{var t;Y(null!==(t=e)&&void 0!==t?t:p)},offset:e=>{V(null===e?v:Number(e))},wrapper:e=>{var t;oe(null!==(t=e)&&void 0!==t?t:f)},events:e=>{const t=null==e?void 0:e.split(" ");ce(null!=t?t:y)},"position-strategy":e=>{var t;se(null!==(t=e)&&void 0!==t?t:S)},"delay-show":e=>{G(null===e?_:Number(e))},"delay-hide":e=>{Q(null===e?g:Number(e))},float:e=>{ee(null===e?A:"true"===e)},hidden:e=>{re(null===e?T:"true"===e)}};Object.values(t).forEach((e=>e(null))),Object.entries(e).forEach((([e,r])=>{var n;null===(n=t[e])||void 0===n||n.call(t,r)}))};i((()=>{z(l)}),[l]),i((()=>{M(s)}),[s]),i((()=>{K(m)}),[m]),i((()=>{Y(p)}),[p]),i((()=>{V(v)}),[v]),i((()=>{G(_)}),[_]),i((()=>{Q(g)}),[g]),i((()=>{ee(A)}),[A]),i((()=>{re(T)}),[T]),i((()=>{se(S)}),[S]),i((()=>{var e;const r=new Set(de);let l=o;if(!l&&t&&(l=`[data-tooltip-id='${t}']`),l)try{document.querySelectorAll(l).forEach((e=>{r.add({current:e})}))}catch(e){console.warn(`[react-tooltip] "${l}" is not a valid CSS selector`)}const c=document.querySelector(`[id='${n}']`);if(c&&r.add({current:c}),!r.size)return()=>null;const i=null!==(e=null!=ae?ae:c)&&void 0!==e?e:pe.current,s=new MutationObserver((e=>{e.forEach((e=>{var t;if(!i||"attributes"!==e.type||!(null===(t=e.attributeName)||void 0===t?void 0:t.startsWith("data-tooltip-")))return;const r=me(i);ve(r)}))})),a={attributes:!0,childList:!1,subtree:!1};if(i){const e=me(i);ve(e),s.observe(i,a)}return()=>{s.disconnect()}}),[de,pe,ae,n,o]);let fe=h;const he=c(null);if(a){const t=a({content:null!=q?q:null,activeAnchor:ae});fe=t?e.createElement("div",{ref:he,className:"react-tooltip-content-wrapper"},t):null}else q&&(fe=q);W&&(fe=e.createElement(j,{content:W}));const ye={id:t,anchorId:n,anchorSelect:o,className:u,classNameArrow:d,content:fe,contentWrapperRef:he,place:P,variant:X,offset:F,wrapper:ne,events:le,openOnClick:w,positionStrategy:ie,middlewares:E,delayShow:Z,delayHide:J,float:U,hidden:te,noArrow:O,clickable:L,closeOnEsc:R,closeOnScroll:k,closeOnResize:N,style:x,position:I,isOpen:C,setIsOpen:$,afterShow:B,afterHide:H,activeAnchor:ae,setActiveAnchor:e=>ue(e)};return e.createElement(D,{...ye})};y({css:`:root{--rt-color-white:#fff;--rt-color-dark:#222;--rt-color-success:#8dc572;--rt-color-error:#be6464;--rt-color-warning:#f0ad4e;--rt-color-info:#337ab7;--rt-opacity:0.9}.core-styles-module_tooltip__3vRRp{visibility:hidden;width:max-content;position:absolute;top:0;left:0;padding:8px 16px;border-radius:3px;font-size:90%;pointer-events:none;opacity:0;transition:opacity 0.3s ease-out;will-change:opacity,visibility}.core-styles-module_fixed__pcSol{position:fixed}.core-styles-module_arrow__cvMwQ{position:absolute;background:inherit}.core-styles-module_noArrow__xock6{display:none}.core-styles-module_clickable__ZuTTB{pointer-events:auto}.core-styles-module_show__Nt9eE{visibility:visible;opacity:var(--rt-opacity)}`,type:"core"}),y({css:`
.styles-module_arrow__K0L3T{width:8px;height:8px;transform:rotate(45deg)}.styles-module_dark__xNqje{background:var(--rt-color-dark);color:var(--rt-color-white)}.styles-module_light__Z6W-X{background-color:var(--rt-color-white);color:var(--rt-color-dark)}.styles-module_success__A2AKt{background-color:var(--rt-color-success);color:var(--rt-color-white)}.styles-module_warning__SCK0X{background-color:var(--rt-color-warning);color:var(--rt-color-white)}.styles-module_error__JvumD{background-color:var(--rt-color-error);color:var(--rt-color-white)}.styles-module_info__BWdHW{background-color:var(--rt-color-info);color:var(--rt-color-white)}`});export{q as Tooltip,A as TooltipProvider,T as TooltipWrapper,w as removeStyle};
